/*
 * LittleOS - http://come.to/littleos/
 * Copyright (C) 1998-2000 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * LittleOS is free software -- also known as "open source" -- you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License, version 2, as published by the Free Software Foundation,
 * and found in the file `COPYING'.  This license basically allows free use,
 * modification, and redistribution, as long as the source to LittleOS and
 * any code linked against it is made freely available.  (The license in
 * `COPYING' is authoritative, not this interpretation of it.)
 *
 * LittleOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with LittleOS; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place #330, Boston, MA 02111-1307, USA, or look
 * at http://www.fsf.org/copyleft/gpl.html.
 *
 */

#ifndef _TSS_H
#define _TSS_H

struct i386_tss
{
    unsigned short back, RESERVED0;
    unsigned long esp0;
    unsigned short ss0, RESERVED1;
    unsigned long esp1;
    unsigned short ss1, RESERVED2;
    unsigned long esp2;
    unsigned short ss2, RESERVED3;
    unsigned long cr3;
    unsigned long eip;
    unsigned long eflags;
    unsigned long eax, ecx, edx, ebx;
    unsigned long esp, ebp, esi, edi;
    unsigned short es, RESERVED4;
    unsigned short cs, RESERVED5;
    unsigned short ss, RESERVED6;
    unsigned short ds, RESERVED7;
    unsigned short fs, RESERVED8;
    unsigned short gs, RESERVED9;
    unsigned short ldt, RESERVED10;
    unsigned short trap;
    unsigned short io;
}
__attribute__((packed));

#endif
