/* Modified by Pascal Lacroix <placr@hotmail.com> for LittleOS */

/* 
 * Copyright (c) 1995 The University of Utah and
 * the Computer Systems Laboratory at the University of Utah (CSL).
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software is hereby
 * granted provided that (1) source code retains these copyright, permission,
 * and disclaimer notices, and (2) redistributions including binaries
 * reproduce the notices in supporting documentation, and (3) all advertising
 * materials mentioning features or use of this software display the following
 * acknowledgement: ``This product includes software developed by the
 * Computer Systems Laboratory at the University of Utah.''
 *
 * THE UNIVERSITY OF UTAH AND CSL ALLOW FREE USE OF THIS SOFTWARE IN ITS "AS
 * IS" CONDITION.  THE UNIVERSITY OF UTAH AND CSL DISCLAIM ANY LIABILITY OF
 * ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * CSL requests users of this software to return to csl-dist@cs.utah.edu any
 * improvements that they make and grant CSL redistribution rights.
 *
 *      Author: Bryan Ford, University of Utah CSL
 */

#include <sys/lmm.h>

extern struct lmm malloc_lmm;

void *malloc(unsigned int size);
void *calloc(unsigned int nelt, unsigned int eltsize);
void *realloc(void *buf, unsigned int new_size);
void free(void *buf);

/* malloc() and realloc() call this routine when they're about to fail;
   it should try to scare up more memory and add it to the malloc_lmm.
   Returns nonzero if it succeeds in finding more memory.  */
int morecore(unsigned int size);
