/*
 * LittleOS - http://come.to/littleos/
 * Copyright (C) 1998-2000 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * LittleOS is free software -- also known as "open source" -- you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License, version 2, as published by the Free Software Foundation,
 * and found in the file `COPYING'.  This license basically allows free use,
 * modification, and redistribution, as long as the source to LittleOS and
 * any code linked against it is made freely available.  (The license in
 * `COPYING' is authoritative, not this interpretation of it.)
 *
 * LittleOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with LittleOS; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place #330, Boston, MA 02111-1307, USA, or look
 * at http://www.fsf.org/copyleft/gpl.html.
 *
 */

#ifndef _SETJMP_H_
#define _SETJMP_H_

typedef struct
{
    unsigned long eip;
    unsigned long edi;
    unsigned long esi;
    unsigned long ebp;
    unsigned long esp;
    unsigned long ebx;
    unsigned long edx;
    unsigned long ecx;
    unsigned long eax;
}
jmp_buf[1];

/*
 * setjmp()
 *      Save context, returning 0
 */
inline static int
setjmp(jmp_buf regs)
{
    register int retcode;

    __asm__ __volatile__(
			    "movl $1f,(%%edi)\n\t"
			    "movl %%esi,8(%%edi)\n\t"
			    "movl %%esp,%%eax\n\t"
			    "movl %%ebp,12(%%edi)\n\t"
			    "subl $4,%%eax\n\t"
			    "movl %%eax,16(%%edi)\n\t"
			    "xorl %%eax,%%eax\n\t"
			    "movl %%ebx,20(%%edi)\n\t"
			    "movl %%edx,24(%%edi)\n\t"
			    "movl %%ecx,28(%%edi)\n"
			    "1:\n\t"
			    :"=a"(retcode)
			    :"D"(regs));

    return (retcode);
}

/*
 * longjmp()
 *      Restore context, returning a specified result
 */
inline static void
longjmp(jmp_buf regs, int retval)
{
    __asm__ __volatile__(
			    "movl 16(%%edi),%%esp\n\t"
			    "movl 12(%%edi),%%ebp\n\t"
			    "movl 8(%%edi),%%esi\n\t"
			    "movl (%%edi),%%edx\n\t"
			    "movl %%edx,(%%esp)\n\t"
			    "movl 20(%%edi),%%ebx\n\t"
			    "movl 24(%%edi),%%edx\n\t"
			    "movl 28(%%edi),%%ecx\n\t"
			    "ret\n\t"
			    :	/* No output */
			    :"D"(regs), "a"(retval));
}

#endif /* _SETJMP_H_ */
