/*
 * LittleOS - http://come.to/littleos/
 * Copyright (C) 1998-2000 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * LittleOS is free software -- also known as "open source" -- you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License, version 2, as published by the Free Software Foundation,
 * and found in the file `COPYING'.  This license basically allows free use,
 * modification, and redistribution, as long as the source to LittleOS and
 * any code linked against it is made freely available.  (The license in
 * `COPYING' is authoritative, not this interpretation of it.)
 *
 * LittleOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with LittleOS; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place #330, Boston, MA 02111-1307, USA, or look
 * at http://www.fsf.org/copyleft/gpl.html.
 *
 */

#ifndef _STRING_H
#define _STRING_H

/* string functions */
char *strcat(char *, const char *);
char *strchr(const char *, int);
int strcmp(const char *, const char *);
char *strcpy(char *to, const char *from);
int strlen(const char *);
char *strncat(char *dst, const char *src, int n);
int strncmp(const char *, const char *, int);
char *strncpy(char *to, const char *from, int count);
char *strstr(const char *, const char *);

/* bcopy.S: copy memory */
void bcopy(void *from, void *to, int bytes);

/* memcpy.S */
char *memcpy(void *dest, const void *from, int bytes);

#define memmove memcpy

/* bzero.S */
void bzero(void *, int);

/* memset.S */
void memset(char *, char, int);

/* is that correct ? */
#define memcmp(mem1, mem2, len) strncmp((char *)(mem1), (char*)(mem2), (len))

#endif
