/*
 * LittleOS - http://come.to/littleos/
 * Copyright (C) 1998-2000 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * LittleOS is free software -- also known as "open source" -- you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License, version 2, as published by the Free Software Foundation,
 * and found in the file `COPYING'.  This license basically allows free use,
 * modification, and redistribution, as long as the source to LittleOS and
 * any code linked against it is made freely available.  (The license in
 * `COPYING' is authoritative, not this interpretation of it.)
 *
 * LittleOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with LittleOS; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place #330, Boston, MA 02111-1307, USA, or look
 * at http://www.fsf.org/copyleft/gpl.html.
 *
 */

#ifndef _INTR_H
#define _INTR_H

#include <types.h>
#include <i386/gdt.h>

/* Interrupt Descriptor Table */
union DTEntry idt[256];

/* enables IRQ number irq_no */
void enable_irq(unsigned short irq_no);

/* disable IRQ number irq_no */
void disable_irq(unsigned short irq_no);

/* disables interrupts */
#define cli() __asm__ __volatile__ ("cli");

/* enables interrupts */
#define sti() __asm__ __volatile__ ("sti");

#define enable_ints sti
#define disable_ints cli

/* structure used to pass the arguments to exception functions */
struct int_frame
{
    long gs, fs, es, ds, edi, esi, ebp, ebx, edx, ecx, eax, err, eip, cs,
        eflags, esp, ss;
};

#endif
