/*
 * LittleOS - http://come.to/littleos/
 * Copyright (C) 1998-2000 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * LittleOS is free software -- also known as "open source" -- you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License, version 2, as published by the Free Software Foundation,
 * and found in the file `COPYING'.  This license basically allows free use,
 * modification, and redistribution, as long as the source to LittleOS and
 * any code linked against it is made freely available.  (The license in
 * `COPYING' is authoritative, not this interpretation of it.)
 *
 * LittleOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with LittleOS; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place #330, Boston, MA 02111-1307, USA, or look
 * at http://www.fsf.org/copyleft/gpl.html.
 *
 */

#ifndef _KERNEL_H
#define _KERNEL_H

#include <types.h>
#include <sys/utsname.h>

/* should be defined in paging.h ? */
#define PAGE_SIZE 4096

/* standard printing routine, like print but use printk while in kernel */
int printk(const char *format,...);

/* panic prints a message and never returns (it halts the system) */
void
panic(const char *format,...) 
__attribute__((noreturn));

     void check_stack(void);	/* entry.asm */

/* call detect_cpu befoee reading cpu_* */
     void detect_cpu(void);

/* cpu vendor return by the CPU */
     char cpu_vendor[16];

/* cpu family: 4=486; 5= Pentium class; 6= Pentium II class... */
     int cpu_family;

/* cpu model: 0= DX; 1= SX; 15= Unknown */
     int cpu_model;

/* is there a Floating Processing Unit ? egals TRUE or FALSE */
     int cpu_fpu;

/* mmx ? egals TRUE or FALSE */
     int cpu_mmx;

/* Is CPUID instruction supported ? contains TRUE or FALSE */
     int cpu_cpuid;

#ifdef INFO
#define info(msg, args...) printk(msg, ## args)

#else /* INFO */
#define info(msg, args...) ((void)0)
#endif

#endif
