/*
 * LittleOS - http://come.to/littleos/
 * Copyright (C) 1998-2000 Lacroix Pascal <placr@hotmail.com>
 * All rights reserved.
 *
 * LittleOS is free software -- also known as "open source" -- you can
 * redistribute it and/or modify it under the terms of the GNU General
 * Public License, version 2, as published by the Free Software Foundation,
 * and found in the file `COPYING'.  This license basically allows free use,
 * modification, and redistribution, as long as the source to LittleOS and
 * any code linked against it is made freely available.  (The license in
 * `COPYING' is authoritative, not this interpretation of it.)
 *
 * LittleOS is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with LittleOS; see the file COPYING.  If not, write to the Free Software
 * Foundation, 59 Temple Place #330, Boston, MA 02111-1307, USA, or look
 * at http://www.fsf.org/copyleft/gpl.html.
 *
 */

#include <i386/gdt.h>
#include <i386/tss.h>

struct i386_tss tss[2];

descTable(gdt, 10)
{
    {
      dummy:0
    }
    ,

    /* kernel segments */
	stndDesc(0x00000000, 0xfffff, (D_CODE + D_READ + D_BIG + D_BIG_LIM)),
	stndDesc(0x00000000, 0xfffff, (D_DATA + D_WRITE + D_BIG + D_BIG_LIM)),

    /* user segments */
	stndDesc(0x00000000, 0xfffff, (D_CODE + D_READ + D_BIG + D_BIG_LIM + D_DPL3)),
	stndDesc(0x00000000, 0xfffff, (D_DATA + D_WRITE + D_BIG + D_BIG_LIM + D_DPL3)),

    /* two TSSes */
	stndDesc(0x00000000, (sizeof(struct i386_tss) - 1), D_TSS),
        stndDesc(0x00000000, (sizeof(struct i386_tss) - 1), D_TSS),

        stndDesc(0x00000000, (8 * 2 - 1), D_LDT),
};

struct
{
    unsigned short limit __attribute__((packed));
    union DTEntry *gdt __attribute__((packed));
}
gdtr =
{
    (7 * sizeof(union DTEntry) - 1), gdt
};
